--------------------------------------------------------------------------------
-- Sance by Holzchopf
-- v1.2 - 28 Sep 2011	- Updated hierarchy
-- v1.1 - 30 Jul 2010	- Updated effects
--						- Ghosts visible in advance
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.seance={}

-- load ressources
holzchopf.seance.gfx_icn=loadgfx("holzchopf/seance.png")
setmidhandle(holzchopf.seance.gfx_icn)
holzchopf.seance.gfx_wpn=loadgfx("weapons/rc.bmp")
holzchopf.seance.sfx=loadsfx("hellfire.ogg")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.seance.id=addweapon("holzchopf.seance","Sance", holzchopf.seance.gfx_icn, 0, 4)

function holzchopf.seance.draw()
	drawinhand(holzchopf.seance.gfx_wpn,7,0)
	hudinfo("Hit [fire] to start sance")
	-- fade background
	weapon_timer=weapon_timer+1
	if weapon_timer<=30 then
		alpha=weapon_timer/50
	end
	setbgcolor(0,0,0,alpha,0.02)
	-- indicate tombs
	if weapon_shots==0 then
		players=playertable(1,1)
		for i=1,#players,1 do
			id=players[i]
			if (getplayerhealth(id)<=0) then
				x=getplayerx(id)
				y=getplayery(id)
				rot=weapon_timer*0.4+(weapon_timer%2)*math.pi
				particle(p_lightpuff,x+math.cos(rot)*7,y-math.sin(rot)*7)
				particlespeed(math.cos(rot)*0.8,-math.sin(rot)*0.8)
				particlesize(5,5)
				particlecolor(255,(weapon_timer%2)*255,255)
				particlealpha(1.0)
				particlefadealpha(0.1)
				outofscreenarrow(x,y)
			end
		end
	end
end

function holzchopf.seance.attack(attack)
	if (weapon_shots==0) and (attack==1) then
		-- disable weapon switching
		useweapon(0)
		weapon_shots=1
		playsound(holzchopf.seance.sfx)
		-- find dead bodies
		players=playertable(1,1)
		for i=1,#players,1 do
			id=players[i]
			if (getplayerhealth(id)<=0) then
				x=getplayerx(id)
				y=getplayery(id)
				arealdamage(x,y,100,150)
				particle(p_ring,x,y)
				particlesize(0.3,0.3)
				particlecolor(255,255,255)
				particlealpha(1.0)
				particlefadealpha(0.1)
				particle(p_muzzle,x,y)
				particlesize(3,3)
				particlecolor(255,128,255)
				particlealpha(1.0)
				particlefadealpha(0.008)
				for j=1,10,1 do
					angle=math.rad(math.random(0,359))
					speed=math.random()
					particle(p_lightpuff,x,y)
					particlesize(5.0,5.0)
					particlecolor(255,255,255)
					particlespeed(math.sin(angle)*speed,math.cos(angle)*speed)
					particlefadealpha(0.008)
				end
				for j=1,30,1 do
					angle=math.rad(math.random(0,359))
					speed=math.random()
					particle(p_lightpuff,x+math.sin(angle)*100,y+math.cos(angle)*100)
					particlesize(3.0,3.0)
					particlecolor(255,0,255)
					particlespeed(-math.sin(angle)*speed,-math.cos(angle)*speed)
					particlefadealpha(0.008)
				end
			end
		end
		-- end turn
		endturn()
	end
end
